/**
 * $Id$
 */
var LocalGroupItemSelector = Class.create({

	initialize : function(table, options) {
		this.table = $(table);
		this.options = options || {};
		// select pulldown
		this.stack = new Element("div").update(this.options.pulldownLeadingLabel || "Add authority:");
		this.table.insert({after: this.stack});
		this.selector = new Element("select").insert(new Element("option"));
		this.selector.onchange = this.add.bind(this);
		this.selector.onmousewheel = doNothing;
		this.stack.insert(this.selector);
		this.stack.hide();
		this.inAnimation = false;
	},

	addItem : function(itemId, title, readCheck, updateCheck, deleteCheck) {
		var row = new Element("tr", {id: "row_" + itemId}).addClassName("bg2");
		this.table.down("tbody").insert(row);	// IE hacking
		// label column
		var input;
		row.insert(new Element("td").addClassName("caption3").update(title ? title.escapeHTML() : title));
		// "Create" column
		row.insert(new Element("td").update('-'));
		// "Read" column
		input = new Element("input", {type: "checkbox", name: "permitRead", value: "FORMITEM:" + itemId});
		row.insert(new Element("td").insert(input));
		// IE hacking: set checked must after hang on DOM to take affect, value must be boolean
		input.checked = !!readCheck;
		// "Update" column
		input = new Element("input", {type: "checkbox", name: "permitUpdate", value: "FORMITEM:" + itemId});
		row.insert(new Element("td").insert(input));
		input.checked = !!updateCheck;
		// "Delete" column
		input = new Element("input", {type: "checkbox", name: "permitDelete", value: "FORMITEM:" + itemId});
		row.insert(new Element("td").insert(input));
		input.checked = !!deleteCheck;
		// "BulkOperate" column, empty for FormItem
		row.insert(new Element("td").update('-'));
		// delBtn
		var img = new Element("img", {src: fixHibikiImageUrl("images/aqbtn_pcm_close_s.gif"), title: this.options.deleteButtonLabel || "Delete" }).addClassName("ImgIco");
		var a = new Element("a", {href: "#"}).insert(img);
		a.onclick = this.remove.bind(this, itemId);
		row.insert(new Element("td").insert(a));
		// options
		if (readCheck || updateCheck || deleteCheck) {
			;
		} else {
			// hide from list
			row.hide();
			// create the option and add it at the end of the selector
			this.selector.insert(new Element("option", {value: itemId}).update(title ? title.escapeHTML() : title));
			if (!this.stack.visible()) {
				this.stack.show();
			}
		}
		return false;
	},

	add : function() {
		if (!this.selector.value)
			return false;

		var itemId = this.selector.value;
		// show on the list
		$('row_'+itemId).appear({
			duration: 0.5,
			beforeStartInternal: function(effect) {
				$('row_'+itemId).select('input').each(function(elm){
					elm.checked = false;
				});
			}
		});
		// remove that option from selector
		var index = -1;
		for (var i=0; i<this.selector.options.length; i++) {
			var option = this.selector.options[i];
			if (option.value == itemId) {
				index = i;
				break;
			}
		}
		if (index >= 0)
			this.selector.remove(index);
		if (this.selector.options.length <= 1) {
			this.stack.fade();
		}
		return false;
	},

	remove : function(itemId) {
		if (!itemId || this.inAnimation)
			// アニメーション途中の再突入防止
			return false;
		if (navigator.userAgent.indexOf("MSIE 6") >= 0) {
			this.inAnimation = true;
			// IE6 対策: 削除時のアニメーションをやめる：IE6では理由不明なjavascriptエラー
			$('row_'+itemId).hide();
			$('row_'+itemId).select('input').each(function(elm){
				// uncheck and hide from the list
				elm.checked = false;
			});
			// use DOM-1 method
			var option = document.createElement('option');
			option.text = $('row_'+itemId).down('td').innerHTML;
			option.value = itemId;
			this.selector.add(option);
			this.inAnimation = false;
		} else {
			$('row_'+itemId).fade({
				duration: 0.5,
				beforeStartInternal: function(effect) {
					this.inAnimation = true;
				}.bind(this),
				afterFinishInternal: function(effect) {
					$('row_'+itemId).select('input').each(function(elm){
						// uncheck and hide from the list
						elm.checked = false;
					});
					$('row_'+itemId).hide();
					this.inAnimation = false;
				}.bind(this)
			});
			// create the option and add it at the end of the selector
			this.selector.insert(new Element("option", {value: itemId}).update($('row_'+itemId).down('td').innerHTML));
			if (typeof this.selector.options.remove !== 'undefined') {
				// IE 対策: penetrate to select.options
				this.selector.options.add(new Element('option'));
			    this.selector.options.remove(this.selector.options.length - 1);
			}
		}
		// display 
		this.stack.appear({duration: 0.2});
		return false;
	}

});