/*jslint white: false, undef: true, browser: true, onevar: false*/
/*global
		window
			console
			confirm
			self
		DA
			DocumentRemote
			DA$SmartDB$Widget$DocumentTree$MESSAGES
			popup_window_open
			singlePopupDivController
			extendTreeDivForIE
			recalcPosition
			escape
			getWidth
			displayContextMenu
		$ Element Event
		YAHOO
		
 */
if (!window.DA2) {
	window.DA2 = {
		SmartDB: { 
			Widget: {}
		}
	};

}

DA2.SmartDB.Widget.DocumentTree = (function () {


var Tree,
	// singleton DOM objects
	MENUICON = new Element("img", {'src' : hibikiImageUrl("brd/contxtmenu")}),
	null_img = "images/null.gif",
	IMGS = {info : fixHibikiImageUrl("images/smartdb/documentlist/smartdb_doclist_btn_info.gif"),
				newdoc : fixHibikiImageUrl("images/smartdb/documentlist/smartdb_doclist_btn_edit.gif"),
				deldoc : fixHibikiImageUrl("images/smartdb/documentlist/smartdb_doclist_btn_delete.gif"),
				delnode : fixHibikiImageUrl("images/brd/doc_node_del_icon.gif")},
	MESSAGES = DA$SmartDB$Widget$DocumentTree$MESSAGES,
	YEvent = YAHOO.util.Event,
	Dom = YAHOO.util.Dom;
//ツリー右側に表示している文書のIDを記録するため
var localRecordId;
	
/**
 * @class DA2.SmartDB.Widget.DocumentTree
 * @constructor
 */
Tree = function (params) {
	
	var me   = this,
		tree = new YAHOO.widget.TreeView(params.containerEl);
	this._disableTreeKeyDownEvents(tree);
	this.menuContainer = params.menuContainerEl;
	window.displayContextMenu = params.displayContextMenu;
	this.binderId = params.binderId;
	this.recordId = params.recordId;
	localRecordId = this.recordId;
	
	DocumentRemote.getTreeData(params.binderId, params.recordId, params.nodeNameItem, params.nodeExpanded, params.displayContextMenu, {
		callback: function(data){
			data = me.decorateData(data);
			tree.buildTreeFromObject(data);
			tree.singleNodeHighlight = true;
			
			tree.subscribe('clickEvent', function (oArgs) {
				var node = oArgs.node,
				    evt  = oArgs.event,
				    menuDiv = Event.findElement(evt, "div.menu-icon");
				if (menuDiv) { // clicked on the menu icon
					me.showContextmenu(evt, node);
				} else { // just a label click
						me.fireEvent('documentNodeClicked', {
							recordId: node.data.recordId,
							binderId: me.binderId,
							isDeleted: node.data.docDeleted });
						if(tree._currentNodeIndex && tree._currentNodeIndex !== node.index){
							tree.onEventToggleHighlight.apply(tree, arguments);
							tree._currentNodeIndex = node.index;
						}
				}
				return false;
			});
			YEvent.on(tree.getEl(), "mouseover", me.treeMouseOver, me, true);
			YEvent.on(tree.getEl(), "mouseout", me.treeMouseOut, me, true);
			tree.render();
			extendTreeDivForIE(params.containerEl);
			// set highlight current node
			var currentNodes = tree.getNodesByProperty("recordId", params.recordId);
			if(currentNodes && currentNodes.length) {
				tree._currentNodeIndex = currentNodes[0].index;
				currentNodes[0].toggleHighlight();
			}
		}
	});
	this.tree = tree;
	this._setupContextmenu();
	
	// Our Custom Events
	/**
	 * @type custom event
	 * @param Object {recordId, isDeleted}
	 */
	this.createEvent('documentNodeClicked');
	
};

YAHOO.widget.SmartDBHTMLNode = function () {
	YAHOO.widget.SmartDBHTMLNode.superclass.constructor.apply(this, arguments); 
};

YAHOO.lang.extend(YAHOO.widget.SmartDBHTMLNode, YAHOO.widget.HTMLNode);

/**
 * @see http://developer.yahoo.com/yui/docs/YAHOO.widget.Node.html
 */
YAHOO.widget.SmartDBHTMLNode.prototype.getHtml = function() {
	this.childrenRendered = false;
	if(typeof(this.data.label) === "undefined"){
		return ['<div class="ygtvitem" id="' , this.getElId() , '">' ,this.getNodeHtml() , this.getChildrenHtml() ,'</div>'].join("");
	} else {
		var width = this.depth * 20 + 40 + getWidth(this.data.label) * 8 + 30;
		return ['<div class="ygtvitem" style="width:' , width, '" id="' , this.getElId() , '">' ,this.getNodeHtml() , this.getChildrenHtml() ,'</div>'].join("");
	}
};

/**
 * base on font size, count the length of string  
 * @param string will be count length
 */
function getWidth(text){
	var width = 0;
	for (var i=0; i<text.length; i++) {
		var n = escape(text.charAt(i));
		if (n.length < 4) {
			width++;
		} else {
			width+=1.5;
		}
	}
	return width;
}

YAHOO.lang.augmentProto(Tree, YAHOO.util.EventProvider);

Tree.prototype._disableTreeKeyDownEvents = function (tree) {
	tree._onKeyDownEvent = function () {};
};

/**
 * @private
 */
Tree.prototype._currentSubContextmenuId = null;

function extendTreeDivForIE(containerEl){
	var isIE = navigator.userAgent.toLowerCase().indexOf("msie") >= 0;
	if (isIE) {
		$(containerEl).insert(new Element('img', {'src' : "images/null.gif", 'width': "1px", 'height' : "20px"}));
	}
}

function decorateWithHTML(data) {
	var newHTML = "<span class='node-label'>" + 
		fixHibikiImageUrl("<a class='doc-label' href='#'><img src='images/brd/doc_node_icon.gif' />") +
		(data.html).escapeHTML() + "</a></span>";
	if(displayContextMenu){
		newHTML += '<div id="mIcon-' + data.recordId + '" class="menu-icon" >' + 
		'<img src="' + hibikiImageUrl("brd/contxtmenu") + '"/></div>';
	}
	return Object.extend(data, {
		html: newHTML,
		className: "show-menu-icon-0",
		children: (data.children||[]).map(decorateWithHTML)
	});
}

Tree.prototype.decorateData = function (data) {
	return decorateWithHTML(data);
};

Tree.prototype._setupContextmenu = function () {
	var tree = this.tree;
	
	this.ctxMenu = $(this.menuContainer);
	this.ctxMenu.observe("mouseover", function (evt) {
		if (evt.element().up('li.submenu')) {
			// show submenu
			var menu = evt.element().up('li.submenu');
			this._currentSubContextmenuId = menu.down('a').readAttribute('subctxId');
			if (this._currentSubContextmenuId) {
				$(this._currentSubContextmenuId).style.display='inline';
			}
		} else if(evt.element().up('div.subcontxtmenu')){ 
			// do nothing
		} else {
			// hide submenu
			if (this._currentSubContextmenuId && $(this._currentSubContextmenuId)) {
				$(this._currentSubContextmenuId).hide();
			}
		}
	}.bind(this));
	this.ctxMenu.observe("mouseenter", function () {
		this._isContextMenuInUse = true;
	}.bind(this));
	this.ctxMenu.observe("mouseout", function () {
		this._isContextMenuInUse = false;
	}.bind(this));
};

/**
 * Where is the mouse over?
 * @type HTMLDOMElement (TD)
 */
Tree.prototype._currentMouseOverTdEl = null;

Tree.prototype.treeMouseOver = function (evt) { 
	
	//singlePopupDivController.hideAll(Event.extend(event));
	if(this.ctxMenu && this.ctxMenu.visible() === false){
		this._isContextMenuInUse = false;
	}
	if (this._isContextMenuInUse) {
		return false;
	}
	var target;
	if ((target = this.tree._getEventTargetTdEl(evt)) && (target = this.tree.getNodeByElement(target)) && (target = target.getEl())) {
		var tdTarget = Element.down(target, ".ygtvtable");
		var mIconEl = Element.down(tdTarget, ".menu-icon");
		if(mIconEl){
			tdTarget.addClassName("show-menu-icon-1").removeClassName("show-menu-icon-0");
			mIconEl.show();
			singlePopupDivController.addFloatDiv(mIconEl);
		}
	}
};

/**
 * flag to indicate that the context menu is in use.
 * @type boolean
 */
Tree.prototype._isContextMenuInUse = false;

Tree.prototype.treeMouseOut = function (evt) {

	if (this._isContextMenuInUse) {//  && (this.ctxMenu && this.ctxMenu.visible())
		return false;
	}
	
	var target;
	if ((target = this.tree._getEventTargetTdEl(evt)) && (target = this.tree.getNodeByElement(target)) && (target = target.getEl())) {
		Element.down(target, ".ygtvtable").addClassName("show-menu-icon-0").removeClassName("show-menu-icon-1");
		this.hideContextmenu(evt);
	}
};

Tree.prototype.hideContextmenu = function (evt) {
	this.ctxMenu.hide();
};

Tree.prototype.showContextmenu = function (evt, node) {
//	this.ctxMenu.show();
	this._isContextMenuInUse = true;
	var ctxMenuIcon = Element.down(node.getEl(), ".menu-icon");
	recalcPosition(this.ctxMenu, evt, ctxMenuIcon);
	DocumentRemote.getNodePermission(this.binderId, node.data.recordId, 
									function (result) {
										this.handleGetNodePermission(result, node, evt);
									}.bind(this));
	singlePopupDivController.addFloatDiv(this.ctxMenu);

};

Tree.prototype._clearCtxMenu = function () {
	this.ctxMenu.innerHTML = ""; // TODO: memory leak!
};

Tree.prototype.handleGetNodePermission = function(result, node, evt) {
	var binderId = this.binderId,
		recordId = node.data.recordId,
		groupMenu = new Element('ul'),
		shouGroutMenu = false;
	
	this._clearCtxMenu();
	
	// info
	if(!result.docDeleted) {
		shouGroutMenu = true;
		groupMenu.insert(this._createMenuItemDocInfo(binderId, recordId));
	}
	// create new doc　「子文書を作成する」リンクを生成する
	if(result.docCreateable && result.childCreateable) {
		shouGroutMenu = true;
		groupMenu.insert(this._createMenuCreateChildDoc(binderId, recordId, result.childCreateable));
	}

	// delete doc
	if (!result.docDeleted && result.docDeleteable) {
		shouGroutMenu = true;
		groupMenu.insert(this._createMenuDeleteDoc(binderId, recordId));
	}
	
	// delete node
	if(result.hierarchyEditable) {
		shouGroutMenu = true;
		var delNodeMenuItem = this._createMenuDeleteNode(binderId, recordId); 
		delNodeMenuItem.insert(this._createMenuSubMenuDeleteNode(result, binderId, recordId, evt));
		groupMenu.insert(delNodeMenuItem);
	}
	if(!shouGroutMenu){
		//操作メニューがありません　メッセージを表示する
		var label = MESSAGES.noOperationMenu;
		var item = new Element('a', {href: '#'}).insert(new Element('span',{'class':'attent'}).update(label));
		item.insert({top : new Element('label').update('&nbsp;&nbsp;&nbsp;&nbsp;')});
		var itemMenu = new Element('li').insert(item);
		groupMenu.insert(itemMenu);
	}
	this.ctxMenu.insert(groupMenu);
	this.ctxMenu.show();
};
Tree.prototype._createMenuItemDocInfo = function(binderId, recordId) {
	var label = MESSAGES.infoLabel;
	var item = new Element('a', {href: '#'})
				.insert(new Element('span').update(label))
				.observe("click", function (evt) {
					evt.stop();
					var url = "BRDDocument.do?func=showInfo&popup=true&binderId=" + binderId + "&recordId="+ recordId;
					popup_window_open(url, '_blank', 800, 450);
				});
	item.insert({top : new Element('img', {src : IMGS.info})});
	var itemMenu = new Element('li').insert(item);
	return itemMenu;
};

Tree.prototype._createMenuCreateChildDoc = function(binderId, recordId) {
	var label = MESSAGES.newDocLabel;
	var item = 
		new Element('a', {href: "javascript:getInheritePopup_ajax(" + recordId + ");"})
			.insert(new Element('span').update(label))
			.insert({top : new Element('img', {src : IMGS.newdoc})});
	var itemMenu = new Element('li').insert(item);
	return itemMenu;
};

Tree.prototype._createMenuDeleteDoc = function(binderId, recordId) {
	var label = MESSAGES.delDocLabel;
	var item = new Element('a', {href: "BRDDocument.do?func=delete&binderId=" + binderId + "&recordId="+ recordId + "&showListButton=true&parts.value(fromdetail)=" + this.recordId}).insert(new Element('span').update(label));
	item.insert({top : new Element('img', {src : IMGS.deldoc})});
	var itemMenu = new Element('li').insert(item);
	return itemMenu;
};

Tree.prototype._createMenuDeleteNode = function(binderId, recordId) {
	var subctxId = 'subCtxMenu_' + recordId;
	var label = MESSAGES.delNodeLable;
	var item = new Element('a', {'class' : 'submenu', href: '#'}).insert(new Element('span').update(label));
	item.writeAttribute({'recordId':recordId,'subctxId':subctxId});
	item.insert({top : new Element('img', {src : IMGS.delnode})});
	var itemMenu = new Element('li', {'class': 'submenu'}).insert(item);
	return itemMenu;
};

Tree.prototype._createMenuSubMenuDeleteNode = function(result, binderId, recordId, evt) {
	//subMenu
	var subctxId = 'subCtxMenu_' + recordId;
	var subGroupMenu = new Element('ul');
	this.insertSubMenu(subGroupMenu, recordId, result.docDeleted, result.docDeleteable);
	var subMenu = new Element('div',{
		'class' : 'contxtmenu subcontxtmenu',
		'style' : 'display: none; margin-top: -25px; left: 198px;',
		'id' : subctxId
		}).update(subGroupMenu);
	return subMenu;
};

Tree.prototype.insertSubMenu = function(groupMenu, recordId, isDeleted, isDeleteable) {
	// move to root
	groupMenu.insert(this._createSubMenuNodeMoveToRoot(this.binderId, recordId));
	
	// move to up above
	groupMenu.insert(this._createSubMenuNodeMoveToUp(this.binderId, recordId));
	
	
	var openingRecId = this.recordId;
	// move to root and delete doc
	if(!isDeleted && isDeleteable) {
		groupMenu.insert(this._createSubMenuNodeMoveToRootAndDelDoc(this.binderId, recordId, openingRecId));
	}

	// move to up above and delete doc
	if(!isDeleted && isDeleteable) {
		groupMenu.insert(this._createSubMenuNodeMoveToUpAndDelDoc(this.binderId, recordId, openingRecId));
	}
};

Tree.prototype._createSubMenuNodeMoveToRoot = function(binderId, recordId, isDeleted) {
	var item = new Element('a', {href: "#"}).insert(new Element('span').update(MESSAGES.nodeMoveToRootLabel));
	item.insert({top : new Element('img', {src : null_img, width : '16', height : '16'})});
	var itemMenu = new Element('li', {'class' : 'sub-item-menu'}).insert(item);
	item.onclick = function(){
		if(confirm(MESSAGES.nodeMoveToRootConfirm)){
			//document.location.href = "BRDDocument.do?func=doDeleteNode&binderId=" + binderId + "&recordId="+ recordId + "&showListButton=true&parts.visible(fromview)=false&treeMoveTo=0&parts.visible(ndocDeleted)=" + isDeleted;
			var url = "func=doDeleteNode&binderId=" + binderId + "&recordId="+ recordId + "&showListButton=true&parts.visible(fromview)=false&treeMoveTo=0&parts.visible(ndocDeleted)=" + isDeleted;
			_clickMenuNodeDelDoc(url);
		}
	};
	return itemMenu;
};

Tree.prototype._createSubMenuNodeMoveToUp = function(binderId, recordId, isDeleted) {
	var item = new Element('a', {href: "#"}).insert(new Element('span').update(MESSAGES.nodeMoveToUpLabel));
	item.insert({top : new Element('img', {src : null_img, width : '16', height : '16'})});
	var itemMenu = new Element('li').insert(item);
	item.onclick = function(){
		if(confirm(MESSAGES.nodeMoveToUpConfirm)){
			//document.location.href = "BRDDocument.do?func=doDeleteNode&binderId=" + binderId + "&recordId="+ recordId + "&showListButton=true&parts.visible(fromview)=false&treeMoveTo=1&parts.visible(ndocDeleted)=" + isDeleted;
			var url = "func=doDeleteNode&binderId=" + binderId + "&recordId="+ recordId + "&showListButton=true&parts.visible(fromview)=false&treeMoveTo=1&parts.visible(ndocDeleted)=" + isDeleted;
			_clickMenuNodeDelDoc(url);
		}
	};
	return itemMenu;
};

Tree.prototype._createSubMenuNodeMoveToRootAndDelDoc = function(binderId, recordId, openingRecId) {
	var url = "func=doDeleteNode&binderId=" + binderId + "&recordId="+ recordId + "&nodeOperation.nodeRecordIdValue=" + openingRecId + "&showListButton=true&parts.visible(fromview)=false&treeMoveTo=0&nDocDel=True";
	var label = MESSAGES.nodeMoveToRootAndDelDocLabel;
	var item = new Element('a', {href: "#"}).insert(new Element('span').update(label));
	item.onclick = function(){_clickMenuNodeDelDoc(url);}
	item.insert({top : new Element('img', {src : null_img, width : '16', height : '16'})});
	var itemMenu = new Element('li').insert(item);
	return itemMenu;
};

Tree.prototype._createSubMenuNodeMoveToUpAndDelDoc = function(binderId, recordId, openingRecId) {
	var url = "func=doDeleteNode&binderId=" + binderId + "&recordId="+ recordId + "&nodeOperation.nodeRecordIdValue=" + openingRecId + "&showListButton=true&parts.visible(fromview)=false&treeMoveTo=1&nDocDel=True";
	var label = MESSAGES.nodeMoveToUpAndDelDocLabel;
	var item = new Element('a', {href: "#"}).insert(new Element('span').update(label));
	item.onclick = function(){_clickMenuNodeDelDoc(url)};
	item.insert({top : new Element('img', {src : null_img, width : '16', height : '16'})});
	var itemMenu = new Element('li').insert(item);
	return itemMenu;
};

function _clickMenuNodeDelDoc(url){
	var form = document.createElement('form');
	document.body.appendChild(form);
	form.action = "BRDDocument.do";
	var params = $H(url.toQueryParams());
	if(form){
		params.each(function(param){
			var hidden = document.createElement('input');
			hidden.type = 'hidden';
			hidden.name = param.key;
			hidden.value = param.value;
			form.appendChild(hidden);
		});
		addCSRFToken(form).submit(); 
	}
}

function recalcPosition(container, event, relObj){
	var isMSIE7   =  navigator.userAgent.indexOf("MSIE 7", 0)>0;
	var isMSIE6   =  navigator.userAgent.indexOf("MSIE 6", 0)>0;
	var dimensions = container.getDimensions();

	var curleft = event.clientX;
	var curtop = event.clientY;
	var obj = relObj;

	curleft += 8;
	var top = curtop;
    var left = curleft;
	
	var scrollX,scrollY;
	if (self.pageYOffset) // all except Explorer
	{
		scrollX = self.pageXOffset;
		scrollY = self.pageYOffset;
	}
	else if (document.documentElement && document.documentElement.scrollTop)
		// Explorer 6 Strict
	{
		scrollX = document.documentElement.scrollLeft;
		scrollY = document.documentElement.scrollTop;
	}
	else if (document.body) // all other Explorers
	{
		scrollX = document.body.scrollLeft;
		scrollY = document.body.scrollTop;
	}

	if(scrollY > 0) {
		top += scrollY;
	}
	
	container.setStyle({
		top: top + 'px',
		left: left + 'px'
	});
}
return Tree; // return the constructor (becomes DA.SmartDB.Widget.DocumentTree)	
}());
