/**
 * $Id: LocalGroupItemSelector.js 46531 2009-08-18 12:25:13Z bai $
 */
var CustomItemSelector = Class.create({

	initialize : function(table, type, options) {
		this.table = $(table);
		this.type = type;
		this.options = options || {};
		// select pulldown
		this.stack = new Element("div").update(this.options.pulldownLeadingLabel || "Add recipient:");
		this.table.insert({after: this.stack});
		this.selector = new Element("select").insert(new Element("option"));
		this.selector.onchange = this.add.bind(this,this.type);
		this.selector.onmousewheel = doNothing;
		this.stack.insert(this.selector);
		this.stack.hide();
		this.inAnimation = false;
	},

	addItem : function(itemId, title, doDisplay) {
		var row = new Element("tr", {id: "row_"+ this.type + "_" + itemId});
		this.table.down("tbody").insert(row);	// IE hacking
		// label column
		row.insert(new Element("td").update(title ? title.escapeHTML() : title));
		// hidden input
		var input = new Element("input", {type: "hidden", name: "notify.to."+ this.type + ".customFormItem", value: itemId});
		row.insert(new Element("td").insert(input));
		var img = new Element("img", {src: fixHibikiImageUrl("images/aqbtn_pcm_close_s.gif"), title: this.options.deleteButtonLabel || "Delete" }).addClassName("ImgIco");
		var a = new Element("a", {href: "#"}).insert(img);
		a.onclick = this.remove.bind(this, itemId);
		row.insert(new Element("td").insert(a));
		
		if(doDisplay){
			;
		}else {
			// hide from list
			row.hide();
			// create the option and add it at the end of the selector
			this.selector.insert(new Element("option", {value: itemId}).update(title ? title.escapeHTML() : title));
			if (!this.stack.visible()) {
				this.stack.show();
			}
		}
		
		return false;
	},

	add : function(type) {
		if (!this.selector.value)
			return false;
		
		if (!type)
			return false;

		var itemId = this.selector.value;
		// show on the list
		$('row_'+type+'_'+itemId).appear({
			duration: 0.5,
			beforeStartInternal: function(effect) {
				$('row_'+type+'_'+itemId).select('input').each(function(elm){
					elm.checked = false;
				});
			}
		});
		// remove that option from selector
		var index = -1;
		for (var i=0; i<this.selector.options.length; i++) {
			var option = this.selector.options[i];
			if (option.value == itemId) {
				index = i;
				break;
			}
		}
		if (index >= 0)
			this.selector.remove(index);
		if (this.selector.options.length <= 1) {
			this.stack.fade();
		}
		setEditFlag();
		return false;
	},

	remove : function(itemId) {
		if (!itemId || this.inAnimation)
			// アニメーション途中の再突入防止
			return false;
		if (navigator.userAgent.indexOf("MSIE 6") >= 0) {
			this.inAnimation = true;
			// IE6 対策: 削除時のアニメーションをやめる：IE6では理由不明なjavascriptエラー
			$('row_'+this.type+'_'+itemId).hide();
			$('row_'+this.type+'_'+itemId).select('input').each(function(elm){
				// uncheck and hide from the list
				elm.checked = false;
			});
			// use DOM-1 method
			var option = document.createElement('option');
			option.text = $('row_'+this.type+'_'+itemId).down('td').innerHTML;
			option.value = itemId;
			this.selector.add(option);
			this.inAnimation = false;
		} else {
			$('row_'+this.type+'_'+itemId).fade({
				duration: 0.5,
				beforeStartInternal: function(effect) {
					this.inAnimation = true;
				}.bind(this),
				afterFinishInternal: function(effect) {
					$('row_'+this.type+'_'+itemId).select('input').each(function(elm){
						// uncheck and hide from the list
						elm.checked = false;
					});
					$('row_'+this.type+'_'+itemId).hide();
					this.inAnimation = false;
				}.bind(this)
			});
			// create the option and add it at the end of the selector
			this.selector.insert(new Element("option", {value: itemId}).update($('row_'+this.type+'_'+itemId).down('td').innerHTML));
			if (typeof this.selector.options.remove !== 'undefined') {
				// IE 対策: penetrate to select.options
				this.selector.options.add(new Element('option'));
			    this.selector.options.remove(this.selector.options.length - 1);
			}
		}
		// display 
		this.stack.appear({duration: 0.2});
		setEditFlag();
		return false;
	}

});