var _useJs = false;

function searchItems() {
    var suffix = _useJs?"JS":"";
    var blockFilter = $("blockFilter" + suffix);
    var searchFilter = $("searchFilter" + suffix);
    var selectableItemsTd = $("selectableItemsTd" + suffix);
    if(!window["selectableItemsTdHtml" + suffix]) {
        window["selectableItemsTdHtml" + suffix] = selectableItemsTd.innerHTML;
    }
    selectableItemsTd.innerHTML = window["selectableItemsTdHtml" + suffix]; // IEでselectのinnerHTMLは設定できません。なので、selectの親TDのinnerHTMLを設定する。
    
    var itemSelect = $("selectableItems" + suffix);
    var itemOptions = itemSelect.childElements();
    
    var blockTitle = blockFilter.options[blockFilter.selectedIndex].innerHTML;
    blockFilter.setAttribute("title", blockTitle);
    
    var searchBlockId = blockFilter.value;
    var searchText = searchFilter.value;
    if(searchText == searchFilter.readAttribute("placeholderText")) {
    	searchText = "";
    }
    searchText = searchText.replace(" ", "");
    
    var showOptions1 = {};
    var complexOptions = [];
    itemOptions.each(function(opt) {
        var show = true;
        var blockId = opt.readAttribute("blockId");
        var optId = opt.readAttribute("optId");
        var pid = opt.readAttribute("pid");
        var optType = opt.readAttribute("optType");
        var optText = opt.innerHTML;
        
        if(searchBlockId != "" && searchBlockId != blockId) {
            show = false;
        }
        
        if(searchText != "" && optText.toLowerCase().indexOf(searchText.toLowerCase()) < 0) {
            show = false;
        }
        
        if(show) {
            showOptions1[optId] = optId;
            if(optType == "lookup" || optType == "list") {
                complexOptions.push(opt);
            }
        }
    });
    
    var showOptions2 = {};
    $A(complexOptions).each(function(opt) {
        var optId = opt.readAttribute("optId");
        var pid = opt.readAttribute("pid");
        var optType = opt.readAttribute("optType");
        var level = optId.split("_").length;
        if(optType == "lookup") { // アカウント部品、或いはバインダ参照ボタン
            var condition = "";
            if(level == 1) {
                condition = "option[pid=" + optId + "]";
            } else {
                condition = "option[optId=" + pid + "]";
            }
            itemSelect.select(condition).each(function(_opt) {
                showOptions2[_opt.readAttribute("optId")] = _opt;
            });
        } else if(optType == "list") { // リスト部品
            var conditions = [];
            if(level == 1) {
                conditions.push("option[optId=" + optId + "_rowCount]");
                conditions.push("option[optId=" + optId + "_sum]");
                conditions.push("option[optId=" + optId + "_average]");
                conditions.push("option[pid=" + optId + "_sum]");
                conditions.push("option[pid=" + optId + "_average]");
            } else if(level == 2) {
                conditions.push("option[optId=" + pid + "]");
                conditions.push("option[pid=" + optId + "]");
            } else if(level == 3) {
                conditions.push("option[optId=" + pid + "]");
                conditions.push("option[optId=" + optId.split("_")[0] + "]");
            }
            
            $A(conditions).each(function(condition) {
                itemSelect.select(condition).each(function(_opt) {
                    showOptions2[_opt.readAttribute("optId")] = _opt;
                });
            });
        }
    });

    itemOptions.each(function(opt) {
        var optId = opt.readAttribute("optId");
        if(!showOptions1[optId] && !showOptions2[optId] && optId != "emptyOption") {
            opt.remove(); // IEでopt.hide()は無効です。
        }
    });
}

function clearSelectHtmlCache() {
	var suffix = _useJs?"JS":"";
	window["selectableItemsTdHtml" + suffix] = null;
}

function searchFocus() {
	var suffix = _useJs?"JS":"";
	var searchFilter = $("searchFilter" + suffix);
	var curText = searchFilter.value;
	var placeholder = searchFilter.readAttribute("placeholderText");
	if(curText == placeholder) {
		searchFilter.value = "";
		searchFilter.style.color = "#000000";
	}
}

function searchBlur() {
	var suffix = _useJs?"JS":"";
	var searchFilter = $("searchFilter" + suffix);
	var curText = searchFilter.value;
	var placeholder = searchFilter.readAttribute("placeholderText");
	if(curText == "") {
		searchFilter.value = placeholder;
		searchFilter.style.color = "rgb(160,160,160)";
	}
}

function setBlockFilterColor() {
	var suffix = _useJs?"JS":"";
	var blockFilter = $("blockFilter" + suffix);
	if(blockFilter.value == "") {
		blockFilter.style.color = "rgb(160,160,160)";
	} else {
		blockFilter.style.color = "#000000";
	}
}
