// 一括操作メニュー
var BulkOperationMenu = Class.create({
	initialize : function(container) {
		this.container = $(container);
	},

	refresh : function(data) {
		// cleanup old contents
		this.container.update('');
		this.tabGroupIds = new Array();
		var setupData = data[data.length -1];
		var groups = setupData.groups;
		var buttons = setupData.buttons;
		this.groupArray = new Array();
		this.groupArray = groups.split(',');
		this.buttonArray = new Array();
		this.buttonArray = buttons.split(',');
		this.createMenu(data);
		return false;
	},
	
	isSettedGroup : function(group) {
		for (var i=0; i<this.groupArray.length; i++) {
			if(this.groupArray[i] === group)
				return true;
		}
		return false;
	},
	
	isSettedButton : function(button) {
		for (var i=0; i<this.buttonArray.length; i++) {
			if(this.buttonArray[i] === button)
				return true;
		}
		return false;
	},

	createMenu : function(data) {
		this._data = data;
		var menuPane = new Element('div', {id : "contents_main"});
		this.container.insert(menuPane);
		var mainTbl = new Element('table');
		var mainTbody = new Element("tbody");
		mainTbl.insert(mainTbody);
		menuPane.insert(mainTbl);
		// menu groups
		// we don't need to execute the last data, because the last data is for another purpose
		data.slice(0, -1).each(function (d) {
		//for (var i=0; i<data.length -1; i++) {
			var groupId = d.id;
			var isChecked = this.isSettedGroup(groupId);
			var cbElm = new Element('input', {
				type: "checkbox",
				name: "bulkOperationGroups", 
				id : "group_" + i,
				value: d.id,
				style : "margin-top: 30px"
			});
			var trElm = new Element('tr').
							insert(new Element('td', {valign : "top"}).
									insert(cbElm));
			mainTbody.insert(trElm);
			// ???? MS IE Error!
			cbElm.checked = isChecked;
			cbElm.onclick = function() {
				if (typeof resetButtonsCheckbox == 'function')
					return resetButtonsCheckbox(cbElm);
				else
					return false;
			};
			var tdElm = new Element('td');
			trElm.insert(tdElm);
			this.createGroup(tdElm, d);
		}.bind(this));

	},

	/**
	 * data in group array specification:
     *  [{
     *      id: group id,
     *      headCss: group header css class, default is "kadomaru_box box_color02",
     *      img: group image, default is "images/smartdb/operations/icon_search.gif",
     *      captionCss: group caption css class, default is "box_caption caption_color02",
     *      caption: group caption,
     *      description: group description,
     *      tabs: [{
     *      	id: tab id,
     *      	label: tab label
     *      },...],
     *      subGroups: [{
     *      	id: subGroup id,
     *      	label: subGroup label
     *      },...],
     *      buttons: [{
     *      	css: button css class, default is "linkmenu  hover01",
     *      	label: button label,
     *      	img: button image, optional,
     *      	description: button description, optional,
     *      	url: menu button url,
     *      	execButtons: [{
     *          	label: execute button label,
     *          	url: execute button url
     *      	}, ...]
     *      },...]
     *  },...],
     *  [{
     *  	groups: group id
     *  	buttons: button id	
     *  }]
     *  
     * @param params 
     */
	createGroup : function(parent, group) {
		menuGroup = new Element('div', {id : group.id});
		parent.insert(menuGroup);
		var header = new Element('div', {style: "width: 400px", 'class' : group.headCss ? group.headCss : "kadomaru_box box_color02"});
		header.insert(new Element('div', {'class' : "box_top"}).insert(new Element('div')));
		if(window.isUseUnifiedUI){
			header.insert(getUnifiedIconElement("unifiedSearchIcon", 36, {style: "float: left;"}));
		}else{
			header.insert(new Element('img', {src : hibikiImageUrl(group.img) || hibikiImageUrl("smartdb/operations/icon_search"), align : "left"}));
		}
		header.insert(new Element('p', {'class' : group.captionCss || "box_caption caption_color02"}).update((group.caption||'').escapeHTML()));
		header.insert(new Element('p', {'class' : "description"}).update(group.description));
		header.insert(new Element('div', {'class' : "box_bottom"}).insert(new Element('div')));
		menuGroup.insert(header);


		// Tabs
		//if (group.tabs) {
			//this.createTabs(group.tabs);
		//}

		// SubGroups
		if (group.id !== "Workflow" && group.subGroups) {
			for (var i=0; i<group.subGroups.length; i++) {
				this.createSubGroup(group.subGroups[i]);
			}
		}

		// Buttons
		if (group.id !== "Workflow" && group.buttons) {
			for (var i=0; i<group.buttons.length; i++) {
				this.createButton(group.buttons[i]);
			}
		}
	},

	createTabs : function(tabs) {
		var parentId = tabs[0].parentId;
		var tabGroupId = parentId + "_tabs";
		var tabGroup = new Element('ul', {id : tabGroupId, 'class' : "tabs"});
		this.tabGroupIds.push(tabGroupId);
		$(parentId).insert(new Element('div', {'class' : "tabmenu"}).insert(tabGroup));
		$(parentId).insert(new Element('br',{style : "clear:both;"}));
		for (var i=0; i<tabs.length; i++) {
			var tab = tabs[i];
			var elm = new Element('li').insert(new Element('a', {href : "#" + tab.id}).insert(new Element('span').update(tab.label)));
			console.log("tab.id:"+tab.id);
			tabGroup.insert(elm);
			$(parentId).insert(new Element('div', {id : tab.id}));
			// SubGroups
			if (tab.subGroups) {
				for (var i=0; i<tab.subGroups.length; i++) {
					this.createSubGroup(tab.subGroups[i]);
				}
			}
			// Buttons
			if (tab.buttons) {
				for (var i=0; i<tab.buttons.length; i++) {
					this.createButton(tab.buttons[i]);
				}
			}
		}
		// init Control.Tabs
		try {
			new Control.Tabs(tabGroupId);
		} catch(e) {
			alert("Exception:\n"+e);
		}
	},

	createSubGroup : function(sub) {
		// サブグループは開く、閉じることができる
		var subGroupHeadId = sub.id + "_head";
		var subGroupHead = new Element('div', {'class' : "process_caption", id : subGroupHeadId}).update((sub.label||'').escapeHTML());
		subGroupHead.insert({top: new Element('img', {src : hibikiImageUrl("smartdb/operations/icon_minus")})});
		if (!$(sub.parentId)) {
			alert("No such element id: " + sub.parentId);
			return;
		}
		$(sub.parentId).insert(subGroupHead);
		$(sub.parentId).insert(new Element('div', {id : sub.id}));

		// Buttons
		if (sub.buttons) {
			for (var i=0; i<sub.buttons.length; i++) {
				this.createButton(sub.buttons[i]);
			}
		}
		subGroupHead.observe('click', function() {
			if ($(sub.id).visible()) {
				$(sub.id).hide();
				$(subGroupHead).down('img').src = hibikiImageUrl('smartdb/operations/icon_plus');
			} else {
				$(sub.id).show();
				$(subGroupHead).down('img').src = hibikiImageUrl('smartdb/operations/icon_minus');
			}
		});
	},
	
	_getButtonId: function (button) {
		return button.id;
	},
	
	/**
	 * var p = {
	 * 	group: ...,
	 *  subgroup: ...
	 *  button: ....
	 * }
	 * 
	 * o.getButton().hide()
	 */
	getButton: function(p) {
		if (typeof p === "string") {
			// means: p is button id
		} else if (typeof p === "object") {
			// get group; get tab, get subgroup, then button...
		}
		var div = null;
		// TODO: buttonのdivを取得する
		div = $(p);
		return div; // div.show(), div.hide() は可能
	},
	
	
	createButton : function(button) {
		var menuItem = new Element('div', {
			id: this._getButtonId(button),
			'class' : button.css || "linkmenu hover01"
		});
		$(button.parentId).insert(menuItem);
		var tblElm;
		if(menuItem.id.indexOf('excel') != -1){
			tblElm = new Element('table',{style : "margin-left :35px"});
		}  else{
			tblElm = new Element('table');
		}
		var tblTbody = new Element("tbody");
		tblElm.insert(tblTbody);
		var trElm = new Element('tr');
		var isChecked = this.isSettedButton(button.id);
		var chkElm = new Element('input', {type : "checkbox", name : "bulkOperationButtons", value : button.id});
		trElm.insert(new Element('td').insert(chkElm));
		var tdElm = new Element('td');
		var item = new Element('label', {style : "padding-left:1em; padding-right:1em"}).insert(new Element('span').update((button.label||'').escapeHTML()));
		tdElm.insert(item);
		trElm.insert(tdElm);
		tblTbody.insert(trElm);
		menuItem.insert(tblElm);
		// ???? MS IE Error!
		// We should set checked attribute after element is added into form
		chkElm.checked = isChecked;
		
		if (button.img) {
			item.insert({top : new Element('img', {src : hibikiImageUrl(button.img)})});
		}
		if (button.description) {
			item.insert({bottom : new Element('span', {'class' : "text_color01"}).update('&nbsp;：&nbsp;' + (button.description||'').escapeHTML())});
		}
		if(menuItem.id.indexOf('doc') != -1 && this._data[1].buttons.length < 4){
			menuItem.down('tr').down('td').down('input').disabled="disabled";
		}
		chkElm.onclick = function() {
			if (typeof resetGroupCheckbox == 'function')
				return resetGroupCheckbox(menuItem, chkElm);
			else
				return false;
		};
	}

});
