var Dialog = {};
Dialog.Box = Class.create();
Object.extend(Dialog.Box.prototype, {
	initialize : function(id) {
		this.createOverlay();

		this.dialog_box = $(id);
		this.dialog_box.show = this.show.bind(this);
		this.dialog_box.hide = this.hide.bind(this);

		this.parent_element = this.dialog_box.parentNode;

		this.dialog_box.style.position = "absolute";

		var e_dims = Element.getDimensions(this.dialog_box);
		var b_dims = Element.getDimensions(this.overlay);

		this.dialog_box.style.left = ((b_dims.width / 2) - (e_dims.width / 2)) + 'px';
		this.dialog_box.style.top = this.getScrollTop()
				+ ((this.winHeight() - (e_dims.width / 2)) / 2)
				+ 'px';
		this.dialog_box.style.zIndex = this.overlay.style.zIndex + 1;
		this.window_refresh = window.refresh;
	},

	createOverlay : function() {
		if ($('dialog_overlay')) {
			this.overlay = $('dialog_overlay');
		} else {
			this.overlay = document.createElement('div');
			this.overlay.id = 'dialog_overlay';
			Object.extend(this.overlay.style, {
				position :'fixed',
				top :0,
				left :0,
				zIndex :90,
				backgroundColor: '#eee',
				display :'none'
			});
			Element.setOpacity(this.overlay, 0.85);
			document.body.insertBefore(this.overlay, document.body.childNodes[0]);
		}
	},

	moveDialogBox : function(where) {
		Element.remove(this.dialog_box);
		if (where == 'back')
			this.dialog_box = this.parent_element
					.appendChild(this.dialog_box);
		else
			this.dialog_box = this.overlay.parentNode
					.insertBefore(this.dialog_box, this.overlay);
	},

	show : function(x,y) {
		this.moveDialogBox('out');
		this.overlay.style.width = "100%";
		this.overlay.style.height = "100%";
		this.overlay.style.display = '';
		this.dialog_box.style.display = '';
		if(x || y){
			this.setPosition(x, y);
		}else{
			this.centering();
		}
		window.refresh = doNothing;

		if (navigator.userAgent.indexOf('MSIE 6') >= 0 && document.forms[0]) {
			// IE6 対策： simulate shim
			var allMenus = Form.getElements(document.forms[0]);
			var activeMenus = Form.getElements(this.dialog_box);
			allMenus.each(function(elm) {
				if (elm.tagName.toLowerCase() == 'select') {
					if (activeMenus.indexOf(elm) < 0)
						elm.hide();
				}
			});
		}
	},

	centering : function() {
		var e_dims = Element.getDimensions(this.dialog_box);
		var left = (this.winWidth() - e_dims.width) / 2;
		var top = this.getScrollTop() + (this.winHeight() - e_dims.height) / 2;
		this.dialog_box.style.left = (left < 0 ? 0 : left) + 'px';
		this.dialog_box.style.top = (top < 0 ? 0 : top) + 'px';
	},
	
	setPosition : function(x,y) {
		this.dialog_box.style.left = x + 'px';
		this.dialog_box.style.top = y + 'px';
	},

	getScrollTop : function() {
		return (window.pageYOffset) ? window.pageYOffset
				: (document.documentElement && document.documentElement.scrollTop) ? document.documentElement.scrollTop
						: document.body.scrollTop;
	},

	hide : function() {
		this.overlay.style.display = 'none';
		this.dialog_box.style.display = 'none';
		this.moveDialogBox('back');
		window.refresh = this.window_refresh;

		if (navigator.userAgent.indexOf('MSIE 6') >= 0 && document.forms[0]) {
			// IE6 対策： simulate shim
			var allMenus = Form.getElements(document.forms[0]);
			var activeMenus = Form.getElements(this.dialog_box);
			allMenus.each(function(elm) {
				if (elm.tagName.toLowerCase() == 'select') {
					if (activeMenus.indexOf(elm) < 0)
						elm.show();
				}
			});
		}
	},

	bodyWidth : function() {
		return document.body.offsetWidth || window.innerWidth
				|| document.documentElement.clientWidth || 0;
	},
	bodyHeight : function() {
		return document.body.offsetHeight || window.innerHeight
				|| document.documentElement.clientHeight || 0;
	},

	winWidth : function() {
		var viewportwidth;

		// the more standards compliant browsers
		// (mozilla/netscape/opera/IE7) use window.innerWidth
		// and window.innerHeight

		if (typeof window.innerWidth != 'undefined') {
			viewportwidth = window.innerWidth;
		}

		// IE6 in standards compliant mode (i.e. with a valid
		// doctype as the first line in the document)

		else if (typeof document.documentElement != 'undefined'
				&& typeof document.documentElement.clientWidth != 'undefined'
				&& document.documentElement.clientWidth != 0) {
			viewportwidth = document.documentElement.clientWidth;
		}

		// older versions of IE

		else {
			viewportwidth = document.getElementsByTagName('body')[0].clientWidth
		}
		return viewportwidth;

	},
	winHeight : function() {
		var viewportheight;

		// the more standards compliant browsers
		// (mozilla/netscape/opera/IE7) use window.innerWidth and
		// window.innerHeight

		if (typeof window.innerHeight != 'undefined') {
			viewportheight = window.innerHeight
		}

		// IE6 in standards compliant mode (i.e. with a valid
		// doctype as the first line in the document)

		else if (typeof document.documentElement != 'undefined'
				&& typeof document.documentElement.clientHeight != 'undefined'
				&& document.documentElement.clientHeight != 0) {
			viewportheight = document.documentElement.clientHeight;
		}

		// older versions of IE

		else {
			viewportheight = document.getElementsByTagName('body')[0].clientHeight;
		}
		return viewportheight;

	}

});
